//========================================================
//HI-MD Renderer Application - Internal functions header file
//
//Written by Mark Collier.
//http://www.marcnetsystem.co.uk/
//
//This program is freeware and may be distributed in part or 
//in whole as long as a the author is credited clearly some way in 
//both the source code and in some visible way when the program 
//is running (eg:in a help screen or version info screen ).

//This notice must also appear in any source file that contains
//any part of the code in this file. 

//I (the author) take no responsability for the loss, transfer, corruption
//duplication, modification, or addition of legal or illegal data in any way. 
//
//Thanks for reading

//MarC


//==============core functions (core.cpp)=====================
void InitCore(LPSTR logfile);
int DoCoreConversion(LPSTR lpstrInFile, LPSTR lpstrTempFile, LPSTR lpstrDestFile,LPSTR errbuff);
void DeinitCore();

//===============windowing (WinFuncs.cpp)===========

BOOL GetInputFileFromAWindow(LPSTR lpstrinfile,DWORD dwBufLen);
BOOL GetSaveFileFromAWindow(LPSTR lpstrinfile,DWORD dwBufLen);
//===============WndLib Stuff (WndLib.cpp==============

typedef LPVOID MARCWNDDATA;
typedef LPVOID MWNDMENU;
typedef void (__cdecl *LPCLICKCALLBACKPROC)(MARCWNDDATA mwnddata,HWND,DWORD,LPVOID,LPVOID);
typedef void (__cdecl *LPCUSTOMMSGCALLBACKPROC)(MARCWNDDATA,HWND hwnd,int iMsg,WPARAM,LPARAM,LPVOID lpvParam);

#define CONTROLTYPE_LISTBOX 0
#define CONTROLTYPE_BUTTON 1
#define CONTROLTYPE_EDITBOX 2
#define CONTROLTYPE_MULTILINEEDITBOX 3
#define CONTROLTYPE_STATIC 4
#define CONTROLTYPE_CHECKBOX 5

#define CONTROLRESIZE_MOVEX		   0x00000001
#define CONTROLRESIZE_MOVEY		   0x00000002
#define CONTROLRESIZE_RESIZEWIDTH  0x00000004
#define CONTROLRESIZE_RESIZEHEIGHT 0x00000008

//when checking event.. only check the low 16 bits of the dwEvent code
#define CLICKEVENT_LEFT 0
#define CLICKEVENT_RIGHT 1
#define CLICKEVENT_DOUBLELEFT 2
#define CLICKEVENT_KEYDOWN 3 //hi-word contains virtual keycode

//wndlib functions....
MARCWNDDATA  MWNDRegisterClass(HINSTANCE hInstance,LPSTR lpstrClassName);
void MWNDUnregisterClass(MARCWNDDATA mwnddata);
BOOL MWNDStartWindow(MARCWNDDATA mwnddata,DWORD dwWidth,DWORD dwHeight,LPSTR lpstrTitle);
void  MWNDSetCustomMsgCallback(MARCWNDDATA wdWnd,int iMsg,LPCUSTOMMSGCALLBACKPROC lpcmcbpCallbackProc, LPVOID lpvParam);
void  MWNDRunMsgLoop();
HWND  MWNDGetHWND(MARCWNDDATA wdWndData);
void  MWNDSetText(HWND hwnd,LPSTR lpstrText);
void MWNDSetTextNumber(HWND hwnd,DWORD dwValue);
DWORD MWNDGetTextNumber(HWND hwnd);
void MWNDGetText(HWND hwnd,LPSTR lpstrBuf,DWORD bufsize);
HWND  MWNDAddControl(MARCWNDDATA wdWndData,
					DWORD dwType,DWORD x,DWORD y,DWORD width,DWORD height,
					LPSTR lpszDisplayText,DWORD dwResizeFlags,
					LPCLICKCALLBACKPROC lpClickCallbackProc,LPVOID lpvPrm1,LPVOID lpvPrm2);
void  MWNDSetControlFont(MARCWNDDATA wdWnd,HWND hwndControl,int iFontHeight,int iFontWidth,
									  BOOL bItallic,BOOL bUnderline,LPSTR lpstrFontname);
void MWNDSetCheckedState(HWND hwndCheckBox,BOOL bChecked);
//===============settings stuff (Settings.cpp)================
#define SETTING_KEEPTMPFILE	1
#define SETTING_DEBUG		2
#define SETTING_BLOCKSIZE	3
#define SETTING_SKIPSIZE	4
#define SETTING_ALLOWEDDIFF	5
#define SETTING_USEAVGING	6
#define SETTING_NOIGNORELONGRPTS 7
#define NUMSETTINGS 7

void SetSetting(DWORD dwIndex,DWORD dwValue);
DWORD GetSetting(DWORD dwIndex);
BOOL CheckFileIsOK(LPSTR name,BOOL bNewFile);
DWORD CheckSettings(LPSTR errbuff);